/*
 * Formula.java
 *
 * George Ferguson, ferguson@cs.rochester.edu, 20 Aug 2002
 * Time-stamp: <Tue Aug 20 10:08:45 EDT 2002 ferguson>
 */

import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import java.util.NoSuchElementException;

public class Formula {
    String predicate;
    LispList args;
    // p(x, y, ...)
    public Formula(String p, LispList args) {
	this.predicate = p;
	this.args = args;
    }
    // arg1 p arg2
    public Formula(String p, Term arg1, Term arg2) {
	this.predicate = p;
	this.args = new LispList();
	this.args.add(arg1);
	this.args.add(arg2);
    }
    // p --> q
    public Formula(String p, Formula arg1, Formula arg2) {
	this.predicate = p;
	this.args = new LispList();
	this.args.add(arg1);
	this.args.add(arg2);
    }
    // A x p
    public Formula(String q, LispList vars, Formula f) {
	this.predicate = q;
	this.args = new LispList();
	this.args.add(vars);
	this.args.add(f);
    }
    // ~ p
    public Formula(String p, Formula f) {
	this.predicate = p;
	this.args = new LispList();
	this.args.add(f);
    }
    public String toString() {
	if (args.isEmpty()) {
	    return "(" + predicate + ")";
	} else {
	    StringBuffer str = new StringBuffer("(");
	    str.append(predicate);
	    ListIterator li = args.listIterator();
	    try {
		while (li.hasNext()) {
		    str.append(" ");
		    str.append(li.next().toString());
		}
	    } catch (NoSuchElementException ex) {
	    }
	    str.append(")");
	    return str.toString();
	}
    }
}
