/*
 * hobbs.lex
 *
 * George Ferguson, ferguson@cs.rochester.edu, 19 Aug 2002
 Time-stamp: <Tue Aug 20 11:10:58 EDT 2002 ferguson>
 * Time-stamp: <>
 */

// Import Symbol type
import java_cup.runtime.Symbol;

%%

// Turn on Java CUP compatibility
%cup
%eofval{
  return new Symbol(sym.EOF);
%eofval}

%%

[ \t\n]+	{ /* eat up whitespace */ }

"("		{ return new Symbol(sym.OPEN_PAREN); }
")"		{ return new Symbol(sym.CLOSE_PAREN); }
"["		{ return new Symbol(sym.OPEN_PAREN); }
"]"		{ return new Symbol(sym.CLOSE_PAREN); }
"-->"		{ return new Symbol(sym.RIGHT_ARROW); }
"<--"		{ return new Symbol(sym.LEFT_ARROW); }
"<-->"		{ return new Symbol(sym.DOUBLE_ARROW); }
"&"		{ return new Symbol(sym.AMPERSAND); }
"v"		{ return new Symbol(sym.V); }
"~"		{ return new Symbol(sym.TILDE); }
"A"		{ return new Symbol(sym.A); }
"E"		{ return new Symbol(sym.E); }
"E!"		{ return new Symbol(sym.E_BANG); }
","		{ return new Symbol(sym.COMMA); }
"="		{ return new Symbol(sym.EQUALS); }
"=/="		{ return new Symbol(sym.NOT_EQUALS); }
"<"		{ return new Symbol(sym.LESS_THAN); }
"<="		{ return new Symbol(sym.LESS_THAN_OR_EQUALS); }
">"		{ return new Symbol(sym.GREATER_THAN); }
">="		{ return new Symbol(sym.GREATER_THAN_OR_EQUALS); }
"+"		{ return new Symbol(sym.PLUS); }
"-"		{ return new Symbol(sym.MINUS); }
"*"		{ return new Symbol(sym.TIMES); }
"/"		{ return new Symbol(sym.DIVIDE); }

[0-9][0-9]*	{ return new Symbol(sym.NUMBER, yytext()); }

[a-zA-Z\*][a-zA-Z0-9_\-\*]*	{ return new Symbol(sym.ID, yytext()); }

.  { System.err.println("Illegal character: "+yytext()); }

